import { Configuration, BlockchainDataModelEntity, Timestamp } from '@energyweb/utils-general';
export interface IRequestIssueOnChainProperties {
    id: string;
    owner: string;
    fromTime: Timestamp;
    toTime: Timestamp;
    deviceId: string;
    approved: boolean;
    revoked: boolean;
}
export declare class Entity extends BlockchainDataModelEntity.Entity implements IRequestIssueOnChainProperties {
    isPrivate: boolean;
    owner: string;
    fromTime: Timestamp;
    toTime: Timestamp;
    deviceId: string;
    approved: boolean;
    revoked: boolean;
    initialized: boolean;
    constructor(id: string, configuration: Configuration.Entity, isPrivate?: boolean);
    sync(): Promise<Entity>;
    approve(toAddress: string, value: number): Promise<number>;
    revoke(): Promise<void>;
    requestMigrateToPublic(value: number): Promise<import("web3-core").TransactionReceipt>;
}
export declare const createRequestIssue: (fromTime: number, toTime: number, deviceId: string, configuration: Configuration.Entity<any, any, any, any, any>, isVolumePrivate?: boolean, forAddress?: string) => Promise<Entity>;
