import Web3 from 'web3';
import { PastEventOptions } from 'web3-eth-contract';
import { GeneralFunctions, ISpecialTx, Timestamp } from '@energyweb/utils-general';
export declare class Issuer extends GeneralFunctions {
    web3: Web3;
    constructor(web3: Web3, address?: string);
    initialize(certificateTopic: number, registryAddress: string, owner: string, txParams: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    getAllEvents(eventFilter?: PastEventOptions): Promise<import("web3-eth-contract").EventData[]>;
    encodeData(_from: Timestamp, _to: Timestamp, _deviceId: string, txParams?: ISpecialTx): Promise<any>;
    decodeData(_data: number[], txParams?: ISpecialTx): Promise<any>;
    getIssuanceRequest(_issuanceRequestId: number, txParams?: ISpecialTx): Promise<any>;
    getIssuanceRequestsForDevice(_deviceId: string, txParams?: ISpecialTx): Promise<any>;
    requestIssuance(_data: any, _isPrivate: boolean, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    requestIssuanceFor(_data: any, _forAddress: string, _isPrivate: boolean, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    approveIssuance(_to: string, _requestId: number, _value: number, _validityData: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    issue(_to: string, _value: number, _data: any, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    approveIssuancePrivate(_to: string, _requestId: number, _commitment: string, _validityData: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    issuePrivate(_to: string, _commitment: string, _data: any, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    revokeRequest(_requestId: number, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    revokeCertificate(_certificateId: number, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    updateCommitment(_id: number, _previousCommitment: string, _commitment: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    requestMigrateToPublic(_certificateId: number, _hash: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    migrateToPublic(_requestId: number, _value: number, _salt: string, _proof: any, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    approvePrivateTransfer(_requestId: number, _proof: any, _previousCommitment: string, _commitment: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    requestPrivateTransfer(_certificateId: number, _hash: string, txParams?: ISpecialTx): Promise<import("web3-core").TransactionReceipt>;
    getRegistryAddress(txParams?: ISpecialTx): Promise<any>;
    version(txParams?: ISpecialTx): Promise<any>;
}
